/*---------------------------------------------------------------------------*/

/*!  \file  rng.h
     \brief  common random number generator  */

/*---------------------------------------------------------------------------*/

/* Copyright (C) 2009 Takashi Uneyama  */

/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

/*---------------------------------------------------------------------------*/
#ifndef INCLUDE_RNG_H
#define INCLUDE_RNG_H

/*---------------------------------------------------------------------------*/
#include "mt.h"

/*---------------------------------------------------------------------------*/
typedef struct rng_state
{
    mt_state *mt;
    int nrand_has_saved_number;
    double nrand_w;
} rng_state;

/*---------------------------------------------------------------------------*/
rng_state *allocate_rng_state(void);
void free_rng_state(rng_state *rng);
void initialize_rng_state(rng_state *rng,unsigned long seed);
double urand(rng_state *rng);
double nrand(rng_state *rng);
int prand(rng_state *rng,double mu);

/*---------------------------------------------------------------------------*/
#endif

/*---------------------------------------------------------------------------*/
