/*---------------------------------------------------------------------------*/

/*!  \file  vector.h
     \brief  definitions for 2,3 dimensional vectors  */

/*---------------------------------------------------------------------------*/

/* Copyright (C) 2007,2009 Takashi Uneyama  */

/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

/*---------------------------------------------------------------------------*/
#ifndef INCLUDE_VECTOR_H
#define INCLUDE_VECTOR_H

/*---------------------------------------------------------------------------*/
typedef float float_vector2[2];
typedef float float_vector3[3];
typedef float float_symmetric_tensor2[3];
typedef float float_symmetric_tensor3[6];
typedef float float_tensor2[2][2];
typedef float float_tensor3[3][3];

typedef double double_vector2[2];
typedef double double_vector3[3];
typedef double double_symmetric_tensor2[3];
typedef double double_symmetric_tensor3[6];
typedef double double_tensor2[2][2];
typedef double double_tensor3[3][3];

typedef double_vector2 vector2;
typedef double_vector3 vector3;
typedef double_symmetric_tensor2 symmetric_tensor2;
typedef double_symmetric_tensor3 symmetric_tensor3;
typedef double_tensor2 tensor2;
typedef double_tensor3 tensor3;

/*---------------------------------------------------------------------------*/
#endif

/*---------------------------------------------------------------------------*/
