/*---------------------------------------------------------------------------*/

/*!  \file  store.h
     \brief  store the state to a HDF5 file  */

/*---------------------------------------------------------------------------*/

/* Copyright (C) 2009 Takashi Uneyama  */

/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

/*---------------------------------------------------------------------------*/
#ifndef INCLUDE_STORE_H
#define INCLUDE_STORE_H

/*---------------------------------------------------------------------------*/
#include "rng.h"
#include "chain.h"
#include "springs.h"

/*---------------------------------------------------------------------------*/
void store_state_to_file_multi_chains(char *h5filename,int m,rng_state *rng,
                                      polymer_chain **chain,
                                      slip_springs **springs);
void store_state_to_file_single_chain(char *h5filename,rng_state *rng,
                                      polymer_chain *chain,
                                      slip_springs *springs);

/*---------------------------------------------------------------------------*/
#endif

/*---------------------------------------------------------------------------*/
